-- Dialogue.lua

local P = createMenuSheet("Dialog")

P.wrapper = nil
P.detailsWindows = {}
P.showing = false

-- Design parameters
P.imageHeight = 50
P.detailImageSize = 100
P.textHeight = 50
P.buttonWidth = 50

function P.onLoad()
    P.wrapper = nil
end

function P.onShow()

    orxonox.CommandExecutor:execute("setTimeFactor 0")
    P.createDialog()
    P.showing = true

end

function P.onHide()
    orxonox.CommandExecutor:execute("setTimeFactor 1")
    P.showing = false
    P.cleanup(true)
end

function P.createDialog()

    local manager = orxonox.DialogManager:getInstance()
    
    
    local personfield = winMgr:getWindow("orxonox/Dialog/Person")
    local person = manager:getPerson()
    personfield:setText(person)

    local questionfiled = winMgr:getWindow("orxonox/Dialog/Question")
    local question = manager:getQuestion()
    questionfiled:setText(question)

    listboxwindow = winMgr:getWindow("orxonox/AnsListbox")

    local themeList = {}
    --[[
    table.insert(themeList, "Default")
    table.insert(themeList, "Drum n' Bass")
    table.insert(themeList, "8-Bit Style")
    table.insert(themeList, "Corny Jazz")
    table.insert(themeList, "Metal")
    --]]
    local anssize = manager:getSize()

    for index = 0, anssize -1, 1 do
        table.insert(themeList, manager:getAnswer(index))
    end  

    for k,v in pairs(themeList) do
        item = CEGUI.createListboxTextItem(v)
        item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
        CEGUI.toListbox(listboxwindow):addItem(item)
    end
end

function P.updateDialog()
    local manager = orxonox.DialogManager:getInstance()
    --manager:update()

    local questionfiled = winMgr:getWindow("orxonox/Dialog/Question")
    local question = manager:getQuestion()
    questionfiled:setText(question)
end

function P.answer_changed(e)
    -- body
end


function P.cleanup(destroyDetails)
    
    if P.wrapper ~= nil then
        winMgr:destroyWindow(P.wrapper)
    end
    
    --Destroy details windows.
    if destroyDetails == false then
        return
    end
    for k,v in pairs(P.detailsWindows) do
        if v ~= nil then
            P.destroyDetailWindow(k)
        end
    end
    
end



function P.Button_clicked(e)
    local ending = orxonox.DialogManager:getInstance():endtest()
    orxonox.CommandExecutor:execute("OrxonoxOverlay toggleVisibility Dialog")
    
    if ending then
        orxonox.CommandExecutor:execute("OrxonoxOverlay toggleVisibility Dialog")
    
    
    else 
        P.updateDialog(index)
    end
end

return P
